This package contains a very simple rewrite of some standard Unix programs. The only purpose
of the exercise is to show how things fit together without distracting details. 
The only thing that is assumed is the kernel - everthing else is rewritten.

- src 	contains the sources of all the commands
- lib   contains the sources of all the library functions
- util	contains a few scripts to build and run the programs

For many programs (sh, ls, login, ...) there are several sources numbered
sequentially. Each version improves the previous one, typically by adding
a single new feature.

The system should run any sufficiently recent version of standard Linux
distributions, such as Ubuntu or Kali.  You can of course run Linux in a VM,
but even WSL2 should work.  Moreover, the sources include assembly for both
Intel and ARM CPUs, so you should be able to run the system also in a Linux VM
running on a Mac M1/2.

The easiesy way to compile everything is to run:
```
	util/install
```
as a normal user. This creates a root directory containing a minimal Unix file
system. Individual programs can be run as, e.g.:
```
	root/bin/sh0
```
You can also run a 'standalone' system which uses only the programs in src, but
you need to be in sudoers and have a proper entry in /etc/subuid and
/etc/subgid. Moreover, xterm and uidmap must be installed in your Linux
distribution. If these conditions are met, you can run
```
	util/start
```
as a normal user. You will be asked for your sudo password.  The script will
start a few xterms, each one emulating a terminal connected to the myUnix
system. Then, it will run the init program to spawn getty on the terminals. You
should see the 'login:' prompt on each one of them.

The initial passwd file defines a couple of normal users (user1 and user2) and
the root user. Passwords are not set, so you can login by just typing enter at
the password prompt.  Once you have logged in, you can use `passwd` to set the
passwords.

When several versions of the same program exist (e.g., sh0, sh1, etc.), the
default one is the highest numbered one. So, for example, /bin/sh is actually
/bin/shG. You can select a different default one when you start the system,
e.g.:
```
	util/start sh=badsh
```
will start the system with /bin/sh pointing to /bin/badsh.

Type ctrl+C on the window where utils/start is running to stop the system.

The number of terminals can be tweaked by editing src/ttys and then running
`util/install` again. Edit src/passwd to add/remove users, followed by
`util/install`. Note that the install script does not delete the previous
file system.

Finally, the programs can also be compiled using the system libraries,
instead of the custom library in lib. Just enter the src directory and
type `make` followed by the name of the program that you want to build.
This should work even on a Mac M1/2 without any VM.
