#include <sys/types.h>
#include <grp.h>
#include <stdio.h>
#include <string.h>
#include <stdlib.h>

#define MAX_LINE  80
#define MAX_USERS 10
#define MAX_FIELDS 4

struct group *getgrnam(const char *name)
{
	static char buf[MAX_LINE];
	static char *users[MAX_USERS + 1];
	static struct group gr;
	FILE *f;
	int n, found;
	size_t i, s;
	char *fields[MAX_FIELDS];

	if ( (f = fopen("/etc/group", "r")) == NULL )
		return NULL;

	found = 0;
	while (fgets(buf, MAX_LINE, f)) {
		n = 0;
		fields[n] = buf;
		s = strlen(buf);
		for (i = 0; i < s && n < MAX_FIELDS; i++) {
			if (buf[i] == ':') {
				buf[i] = '\0';
				n++;
				fields[n] = &buf[i + 1];
			} 
		}
		buf[i - 1] = '\0';
				
		if (!strcmp(fields[0], name)) {
			found = 1;
			break;
		}
	}
	if (found) {
		gr.gr_name = fields[0];
		gr.gr_passwd = fields[1];
		gr.gr_gid = atoi(fields[2]);
		gr.gr_mem = users;
		n = 0;
		users[0] = &buf[i];
		for ( ; i < s && n < MAX_USERS; i++) {
			if (buf[i] == ',') {
				buf[i] = '\0';
				n++;
				users[n] = &buf[i + 1];
			} 
		}
		users[n] = NULL;
	}
	fclose(f);
	return found ? &gr : NULL;
}
