#include <sys/ioctl.h>
#include <termios.h>
#include <unistd.h>
#include <stdio.h>
#include <string.h>

#define MAXPW 20

char *getpass(const char *prompt)
{
	static char pw[MAXPW];
	struct termios s, t;
	char *p;

	ioctl(0, TCGETS, &t);
	s = t;
	t.c_lflag &= ~(ECHO|ISIG);	
	ioctl(0, TCSETS, &t);
	printf("%s", prompt);
	fgets(pw, MAXPW, stdin);
	if ( (p = rindex(pw, '\n')) != NULL )
		*p = '\0';
	ioctl(0, TCSETS, &s);
	printf("\n");
	return pw;
}
