#include <sys/types.h>
#include <pwd.h>
#include <stdio.h>
#include <string.h>
#include <stdlib.h>

#define MAX_LINE  80
#define MAX_FIELDS 7

struct passwd *getpwuid(uid_t uid)
{
	static char buf[MAX_LINE];
	static struct passwd pw;
	FILE *f;
	int n, found;
	size_t i, s;
	char *fields[MAX_FIELDS];

	if ( (f = fopen("/etc/passwd", "r")) == NULL )
		return NULL;

	found = 0;
	while (fgets(buf, MAX_LINE, f)) {
		n = 0;
		fields[n] = buf;
		s = strlen(buf);
		for (i = 0; i < s && n < MAX_FIELDS; i++) {
			if (buf[i] == ':') {
				buf[i] = '\0';
				n++;
				fields[n] = &buf[i + 1];
			} 
		}
		buf[i - 1] = '\0';
				
		if (uid == (uid_t)atoi(fields[2])) {
			found = 1;
			break;
		}
	}
	if (found) {
		pw.pw_name = fields[0];
		pw.pw_passwd = fields[1];
		pw.pw_uid = atoi(fields[2]);
		pw.pw_gid = atoi(fields[3]);
		pw.pw_gecos = fields[4];
		pw.pw_dir = fields[5];
		pw.pw_shell = fields[6];
	}
	fclose(f);
	return found ? &pw : NULL;
}
