#include <stddef.h>

#define MAXPATH 256

char *nextpath(const char **paths, const char *file)
{
	static char buf[MAXPATH + 1], *d;

	if (*paths == NULL)
		return NULL;

	// copy the current path into buf
	d = buf;
	while (**paths != '\0' &&  **paths != ':') {
		if (d - buf > MAXPATH)
			goto path_err;
		*d++ = *(*paths)++;
	}
	// if is is not the last one, advance p for the next cycle,
	// else terminate the search
	*paths = **paths == '\0' ? NULL : *paths + 1;
	// put a '/' separator if necessary
	if (d != buf && *(d - 1) != '/') {
		if (d - buf > MAXPATH)
			goto path_err;
		*d++ = '/';
	}
	// append the file name
	while (*file != '\0' && d - buf <= MAXPATH)
		*d++ = *file++;
	if (d - buf > MAXPATH)
		goto path_err;
	*d = '\0';
	return buf;

path_err:
	*paths = (void *)-1;
	return NULL;
}
