#include <sys/ioctl.h>
#include <stdlib.h>
#include <stdio.h>
#include <unistd.h>

#define TIOCGPTN 0x80045430

char *ptsname(int fd) {
	#define BUFSIZE 1024
	static char buf1[BUFSIZE];
	char buf2[BUFSIZE];
	int ptyno;

	if (ioctl(fd, TIOCGPTN, &ptyno) < 0)
		return NULL;

	snprintf(buf1, BUFSIZE, "/dev/pty%d", ptyno);
	snprintf(buf2, BUFSIZE, "/dev/pts/%d", ptyno);
	unlink(buf1);
	if (symlink(buf2, buf1) < 0)
		return NULL;

	return buf1;
}
