#include <stdlib.h>
#include <string.h>
#include <malloc.h>

extern char **environ;

char *setvar(const char *name, size_t len, const char *value)
{
	char *np;

	if ( (np = malloc(len + strlen(value) + 2)) == NULL)
		return NULL;
	strcpy(np, name);
	strcpy(np + len, "=");
	strcpy(np + len + 1, value);
	return np;
}

int setenv(const char *name, const char *value, int overwrite)
{
	size_t len = strlen(name);
	char **p = environ;
	char *np;
	int i;

	for ( ; *p != NULL; p++) {
		if (!strncmp(*p, name, len)) {
			if (!overwrite)
				return 0;
			if ( (np = setvar(name, len, value)) == NULL )
				return -1;
			*p = np;
			return 0;
		}
	}
	if ( (p = malloc((p - environ + 2) * sizeof(char *))) == NULL )
		return -1;
	for (i = 0; *environ != NULL; i++)
		p[i] = *environ++;
	if ( (p[i] = setvar(name, len, value)) == NULL ) {
		free(p);
		return -1;
	}
	p[i+1] = NULL;
	environ = p;
	return 0;
}
