#include <unistd.h>
#include <signal.h>

sighandler_t signal(int signo, sighandler_t h)
{
	struct sigaction act, oldact;

	act.sa_handler = h;
	act.sa_sigaction = NULL;
	sigemptyset(&act.sa_mask);
	sigaddset(&act.sa_mask, signo);
	act.sa_flags = SA_RESTART;
	if (sigaction(signo, &act, &oldact) < 0)
		return SIG_ERR;
	return oldact.sa_handler;
}
