#include <sys/types.h>

#define SIGHUP 1
#define SIGINT 2
#define SIGQUIT 3
#define SIGTERM 15
#define SIGCHLD 17
#define SIGCONT 18
#define SIGTSTP	20
#define SIGTTIN	21
#define SIGTTOU 22

typedef void (*sighandler_t)(int);
#define SIG_IGN ((sighandler_t)1)
#define SIG_DFL ((sighandler_t)0)
#define SIG_ERR ((sighandler_t)-1)
#define SA_RESTART	0x10000000
#define SA_RESTORER	0x04000000
typedef struct siginfo siginfo_t;
typedef struct {
    unsigned long val[16];
} sigset_t;
struct sigaction {
	void     (*sa_handler)(int);
	void     (*sa_sigaction)(int, siginfo_t *, void *);
	sigset_t   sa_mask;
	int        sa_flags;
	void     (*sa_restorer)(void);
};
int sigaction(int signum, const struct sigaction *act, struct sigaction *oldact);
sighandler_t signal(int signum, sighandler_t handler);
int kill(pid_t pid, int sig);
int sigemptyset(sigset_t *set);
int sigaddset(sigset_t *set, int signum);
