#include <stddef.h>
#include <stdarg.h>
#define EOF (-1)

struct FILE {
	int fd;
	int lastc;
	int eof;
};

typedef struct FILE FILE;
extern FILE *stdin, *stdout, *stderr;
int printf(const char *fmt, ...);
int fprintf(FILE *f, const char *fmt, ...);
int snprintf(char *buf, size_t len, const char *fmt, ...);
int sprintf(char *buf, const char *fmt, ...);
int vsnprintf(char *buf, size_t len, const char *fmt, va_list ap);
void perror(const char *buf);
FILE *fopen(const char *path, const char *mode);
int fclose(FILE *f);
char *fgets(char *s, int size, FILE *f);
int rename(const char *newpath, const char *oldpath);
int fscanf(FILE *f, const char *fmt, ...);
int fgetc(FILE *f);
int ungetc(int c, FILE *f);
int fileno(FILE *f);
