#include <ctype.h>
#include <stdlib.h>

char locase(char c)
{
	if (c >= 'A' && c <= 'Z')
		return c - 'A' + 'a';
	return c;
}

int value(char c)
{
	if (c >= '0' && c <= '9')
		return c - '0';
	c = locase(c);
	if (c >= 'a' && c <= 'z')
		return c - 'a' + 10;
	return -1;
}

long strtol(const char *nptr, const char **endptr, int base)
{
	long rv;
	int sign;
	int v;

	while (isspace(*nptr))
		nptr++;

	if (*nptr == '-' || *nptr == '+') {
		sign = *nptr == '+' ? 1 : -1;
		nptr++;
	} else {
		sign = 1;
	}

	if (base == 16 && *nptr == '0' && locase(*(nptr+1)) == 'x') {
		nptr += 2;
	} else if (base == 0) {
		base = 10;
		if (*nptr == '0') {
			if (locase(*(nptr+1)) == 'x') {
				base = 16;
			} else {
				base = 8;
			}
		}
	}

	rv = 0;
	while ( (v = value(*nptr)) >= 0 && v < base ) {
		rv = rv * base + v;
		nptr++;
	}

	if (endptr)
		*endptr = nptr;
	return sign * rv;
}
