#include <sys/ioctl.h>
#include <termios.h>

int tcsetattr(int fd, int optional_actions, const struct termios *termios_p)
{
	unsigned long int cmd;

	switch (optional_actions) {
	case TCSANOW:
		cmd = TCSETS;
		break;
	case TCSADRAIN:
		cmd = TCSETSW;
		break;
	case TCSAFLUSH:
		cmd = TCSETSF;
		break;
	default:
		return -1;	
	}
	return ioctl(fd, cmd, termios_p);
}
