#include <sys/stat.h>
#include <unistd.h>
#include <stdlib.h>
#include <stdio.h>

/* simple version: accepts only numeric uids
 *
 * Note: the chown() syscall takes both the uid and the gid,
 * so we need to stat() the files to get their current gid
 * to leave it unchanged
 */

int main(int argc, char *argv[])
{
	uid_t u;
	int i, errors;
	struct stat statbuf;

	if (argc < 3) {
		fprintf(stderr, "usage: chown <uid> <path>...\n");
		exit(1);
	}

	u = atoi(argv[1]);

	errors = 0;
	for (i = 2; i < argc; i++) {
		if (stat(argv[i], &statbuf) < 0 || 
		    chown(argv[i], u, statbuf.st_gid) < 0) {
			perror(argv[i]);
			errors++;
			continue;
		}
	}	
	return errors;
}
