#include <string.h>
#include <stdio.h>
#include <stdlib.h>

#define MAX_LINE 1024

/* support multiple arguments */

int do_grep(const char *str, FILE *f, const char *name)
{
	char buf[MAX_LINE];
	int notfound = 1;
	char *p;

	while ( fgets(buf, MAX_LINE, f) ) {
		p = strchr(buf, '\n');
		if (p != NULL)
			*p = '\0';
		if (strstr(buf, str)) {
			notfound = 0;
			if (name)
				printf("%s:", name);
			printf("%s\n", buf);
		}
	}
	return notfound;
}


int main(int argc, char* argv[])
{
	int i;
	int printname = 0;
	FILE *f;
	int notfound = 1;

	if (argc < 2) {
		exit(1);
	}
	if (argc == 2) 
		return do_grep(argv[1], stdin, NULL);	
	printname = (argc > 3);
	for (i = 2; i < argc; i++) {
		if ( !(f = fopen(argv[i], "r")) ) {
			perror(argv[i]);
			continue;
		}
		notfound &= do_grep(argv[1], f, printname? argv[i] : NULL);
		fclose(f);
	}
	return notfound;
}
