#include <fcntl.h>
#include <stdlib.h>
#include <unistd.h>
#include <sys/wait.h>
#include <grp.h>

struct gettys {
	int pid;
	char tty[5];
} gettys[10];


void spawn(int i) {
	int pid = fork();
	if (pid == 0) {
		setsid();
		execl("/bin/getty", "getty", gettys[i].tty, NULL);
		exit(1);
	}
	gettys[i].pid = pid;
}


int main()
{
	int max, i, fd, pid;

	setsid();
	setgroups(0, NULL);

	fd = open("/etc/ttys", O_RDONLY);

	max = 0;
	while(read(fd, gettys[max].tty, 5)) {
		gettys[max].tty[4] = '\0';
		max++;
	}
	close(fd);

	for (i = 0; i < max; i++) 
		spawn(i);

	for (;;) {
		pid = wait(0);

		for (i = 0; i < max; i++) 
			if (gettys[i].pid == pid)
				spawn(i);
	}

	return 0;
}
