#include <sys/types.h>
#include <stdlib.h>
#include <signal.h>
#include <stdio.h>

/* support selection of signal and multiple arguments */

int main(int argc, char *argv[])
{
	int signo = SIGTERM;
	int i, errors;

	if (argc < 2) {
		fprintf(stderr, "usage: kill [-signo] pid\n");
		exit(1);
	}

	if (argc > 2) {
		signo = -atoi(argv[1]);
		argv++;
		argc--;
	}

	errors = 0;
	for (i = 1; i < argc; i++) {
		if (kill(atoi(argv[1]), signo) < 0) {
			perror("kill");
			errors++;
		}
	}
	return errors;
}
