#include <sys/stat.h>
#include <unistd.h>
#include <stdlib.h>
#include <string.h>
#include <crypt.h>
#include <pwd.h>
#include <grp.h>

/*
 * login that changes the owner of the terminal
 */

#define MAX_LINE  80

int main(int argc, char* argv[])
{
	char *pass;
	struct passwd *pw;
	char salt[3];
	struct group *gr;
	gid_t ttygr;

	if (argc < 2)
		return 1;

	pass = getpass("Password: ");

	if ( (pw = getpwnam(argv[1])) == NULL )
		exit(1);
	
	if (strcmp(pw->pw_passwd, "") != 0) {
		salt[0] = pw->pw_passwd[0];
		salt[1] = pw->pw_passwd[1];
		salt[2] = '\0';

		if (strcmp(crypt(pass, salt), pw->pw_passwd) != 0)
			exit (1);
	}

	if ( (gr = getgrnam("tty")) != NULL )
		ttygr = gr->gr_gid;
	else
		ttygr = 0;

	setenv("USER", pw->pw_name, 1);

	fchown(0, pw->pw_uid, ttygr);
	setgid(pw->pw_gid);
	setuid(pw->pw_uid);
	fchmod(0, 0600);

	setenv("HOME", pw->pw_dir, 1);
	chdir(pw->pw_dir);

	setenv("SHELL", pw->pw_shell, 1);
	execl(pw->pw_shell, "-sh", NULL);
	exit(1);
}
