#include <sys/wait.h>
#include <stdlib.h>
#include <stdio.h> /* for perror() */
#include <unistd.h>

#define MAX_LINE 1024
#define MAX_ARGS 10

/* shell that splits lines into words */

int main()
{
	char buf[MAX_LINE];
	int i, n;
	int c_argc;
	char *c_argv[MAX_ARGS + 1];

	while ( (n = read(0, buf, MAX_LINE)) > 1 ) {

		buf[n - 1] = '\0';

		c_argv[0] = buf;
		c_argc = 1;
		for (i = 0; i < n && c_argc < MAX_ARGS; i++) {
			if (buf[i] == ' ') {
				buf[i] = '\0';
				c_argv[c_argc++] = &buf[i + 1];
			}
		}
		c_argv[c_argc] = NULL;

		if (fork()) {
			wait(0);
		} else {
			execvp(buf, c_argv);
			perror(buf);
			exit(1);
		}
	}
	return 0;
}
