#include <sys/stat.h>
#include <unistd.h>
#include <string.h>
#include <stdio.h>
#include <stdlib.h>

#define MAXPATH 256

char* basename(char *p)
{
	char* s = rindex(p, '/');

	if (s)
		return s + 1;
	else
		return p;
}

char* path_append(char *s1, char* s2)
{
	static char buf[MAXPATH+1];

	if (strlen(s1) + strlen(s2) + 1 > MAXPATH)
		return NULL;
	snprintf(buf, MAXPATH+1, "%s/%s", s1, s2);
	return buf;
}


int main(int argc, char* argv[])
{
	struct stat st;
	if (argc < 3) {
		fprintf(stderr, "argomenti insufficienti\n");
		exit(1);
	}

	if (stat(argv[argc - 1], &st) < 0) {
		perror(argv[argc - 1]);
		exit(1);
	}
	if (S_ISDIR(st.st_mode)) {
		int i;
		for (i = 1; i < argc -1; i++) {
			char *npath = path_append(argv[argc - 1], basename(argv[i]));
			if (rename(argv[i], npath) < 0) {
				perror(argv[i]);
				continue;
			}
		}
	} else {
		if (argc != 3) {
			fprintf(stderr, "%s: non e' una directory\n", argv[argc - 1]);
			exit(1);
		}
		if (rename(argv[1], argv[2]) < 0) {
			perror("mv");
			exit(1);
		}
	}
	return 0;
}
