#include <stdio.h>
#include <string.h>

#define MAX_LINES 100
#define MAX_SIZE 4096

char buf[MAX_SIZE];
char *lines[MAX_LINES];
int pos = 0, ln = 0;

void sort()
{
	int i, j;
	for (i = 0; i < ln; i++)
		for (j = i + 1; j < ln; j++)
			if (strcmp(lines[i], lines[j]) > 0) {
				char* tmp = lines[i];
				lines[i] = lines[j];
				lines[j] = tmp;
			}
}

void input(FILE* f)
{
	while ( ln < MAX_LINES &&
		pos < MAX_SIZE &&
		(lines[ln] = fgets(buf + pos, MAX_SIZE - pos, f)) )
	{
		pos += strlen(lines[ln]) + 1;
		ln++;
	}
}

void output()
{
	int i;
	for (i = 0; i < ln; i++)
		printf("%s", lines[i]);
}

int main(int argc, char* argv[])
{
	int i;
	if (argc > 1) {
		for (i = 1; i < argc; i++) {
			FILE *f;
			if ( !(f = fopen(argv[i], "r")) ) {
				perror(argv[i]);
				continue;
			}
			input(f);
			fclose(f);
		}
	} else
		input(stdin);
	sort();
	output();
	return 0;
}
