#include <sys/stat.h>
#include <ctype.h>
#include <fcntl.h>
#include <unistd.h>
#include <stdio.h>
#include <pwd.h>

int main(int argc, char *argv[])
{
	struct passwd *pw1, *pw2;
	struct stat statbuf;
	char buf[] = "/dev/tty0";
	char *p = "tp";
	char c;
	int found;

	if (argc != 2) {
		fprintf(stderr, "usage: write <user>\n");
		return 1;
	}

	if ( (pw1 = getpwuid(getuid())) == NULL ) {
		fprintf(stderr, "internal error\n");
		return 1;
	}

	if ( (pw2 = getpwnam(argv[1])) == NULL ) {
		fprintf(stderr, "no such user\n");
		return 1;
	}

	found = 0;
	for (buf[5] = *p++; buf[5] != '\0'; buf[5] = *p++) {
		for (buf[8] = 0; buf[8] <= '9'; buf[8]++) {
			if (stat(buf, &statbuf) < 0)
				continue;
			if (statbuf.st_uid == pw1->pw_uid) {
				found = 1;
				break;
			}
		}
	}
	if (!found || !(statbuf.st_mode & 0020)) {
		fprintf(stderr, "cannot receive replies\n");
		return 1;
	}

	found = 0;
	for (buf[5] = *p++; buf[5] != '\0'; buf[5] = *p++) {
		for (buf[8] = '0'; buf[8] <= '9'; buf[8]++) {
			if (stat(buf, &statbuf) < 0)
				continue;
			if (statbuf.st_uid == pw2->pw_uid) {
				found = 1;
				break;
			}
		}
	}
	
	if (!found) {
		fprintf(stderr, "not logged in\n");
		return 1;
	}
	if (!(statbuf.st_mode & 0020)) {
		fprintf(stderr, "not accepting messages\n");
		return 1;
	}

	close(1);
	if (open(buf, O_WRONLY) < 0) {
		perror(buf);
		return 1;
	}
	printf("Message from %s\n", pw1->pw_name);

	while (read(0, &c, 1) > 0) {
		if (c < 32 && !isspace(c))
			continue;
		write(1, &c, 1);
	}
}
